      subroutine cixsec
!       setup Air media for cross-section calculations
      use modXsecMedia
      implicit none
#include "Zglobalc.h"
#include "Ztrackp.h"
#include "Ztrack.h"
#include "Ztrackv.h"
#include "Zevhnv.h"
#include "Zcode.h"

c     c
      
!      real*8 shp, xsecmin, xsecstep
!      parameter ( xsecmin = 10.d0, xsecstep = 10 )
      integer i, j, mbindex, jcon
      integer,parameter::noOfElem = 3
      real(8),save::elemA(noOfElem)=(/14.0d0, 16.0d0, 40.0d0/)
      real(8),save::elemZ(noOfElem)=(/7.0d0, 8.0d0, 18.0d0/)
      real(8),save::No(noOfElem)=(/1.56d0, 0.42d0, 0.01d0/)
!      elemS(noOfElem, nxsec), sigma(nxsec)
!      real*8  cumsigma(noOfElem, nxsec)

      real*8  u, tgA, tgZ

      real*8 sumN

      
c      TargetMassN = 14.55   !  sum( Ai*Noi)  / sum (Noi )
c      TargetAtomicN = 7.266  !  sum( Zi*Noi) / sum(Noi)
c      TargetZ2 = 53.54  (cf. <Z>^2 =  52.8)

      sumN = sum( No(:) )
      No(:) = No(:) /sumN

      TargetMassN =sum( No(:)*elemA(:) )
      TargetAtomicN = sum(No(:)*elemZ(:))
      call cAllocXsMediaArray(1)
      call cAllocXsElemArray(1,noOfElem)

      media(1)%name = "Air"
      media(1)%noOfElem = noOfElem
      media(1)%elem(:)%A = elemA(:)
      media(1)%elem(:)%Z = elemZ(:)
      media(1)%elem(:)%No = No(:)
!      mfp = A2deninv*TargetMassN/xs ! in kg/m2
      media(1)%mbtoPkgrm = 1.d0/(A2deninv*TargetMassN)
!      then, mfp   = 1/(mbtoPkgrm*xs)  ! in kg/m2
      TargetZ2 = sum( No(:)*elemZ(:)**2 )
!      TargetZ2_3rd = TargetAtomicN**0.66666
      TargetZ2_3rd = sum( No(:)*elemZ(:)**(2.d0/3.d0) )
!      TargetZ1_3rd = TargetAtomicN**0.33333
      TargetZ1_3rd = sum( No(:)*elemZ(:)**(1.d0/3.d0) )
c//////////
!     <A>=   14.5527638190955     
!     <Z>=   7.26633165829146     
!     <Z^2>=   53.5477386934673     
!     <Z>^2=   52.7995757682887     
!     <Z>^(2/3)=   3.75149534225373     
!     <Z>^(1/3)=   1.93687773033140     
!     <Z^(2/3)>=   3.74733626838206     
!     <Z^(1/3)>=   1.93486427511770     
      write(0,*) "<A>=", TargetMassN
      write(0,*) "<Z>=", TargetAtomicN 
      write(0,*) "<Z^2>=", TargetZ2
      write(0,*) "<Z>^2=", TargetAtomicN**2
      write(0,*) "<Z^(2/3)>=", TargetZ2_3rd
      write(0,*) "<Z^(1/3)>=", TargetZ1_3rd
c//////////// 

      mediumNo=1  ! for Air, fixed
      TargetNucleonNo = 14   !  these 2  will be updated 
      TargetProtonNo =7      !  for each collision (also TargetXs)
          !  Target... were used before xsmedia was introduced
          ! in Cosmos.  We can live without Target.. but
          ! are kept for easy modifcation.
!      do j = 1, noOfElem
!         shp = xsecmin          ! (say 10mb)
!         do i = 1, nxsec
!            call cxp2xAXsec(elemA(j), shp,elemS(j,i))
!            shp = shp + xsecstep
!         enddo
!      enddo


!      do i = 1, nxsec
!         sigma(i) = 0.
!         do j = 1, noOfElem
!            sigma(i) = sigma(i) + No(j)* elemS(j,i)
!         enddo
!      enddo

!      do i = 1, nxsec
!         do j = 1, noOfElem
!            cumsigma(j, i) =
!     *           No(j)*elemS(j,i)/sigma(i)
!         enddo
!      enddo
!
!      do i = 1, nxsec
!         do j = 2, noOfElem
!            cumsigma(j, i) = 
!     *         cumsigma(j, i) + cumsigma(j-1, i)
!         enddo
!c          for safety
!         cumsigma(noOfElem, i) = 1.0
!      enddo
c  &&&&&&
c      do i = 1, nxsec
c         write(*,*) ' sigma=', sigma(i)
c         write(*,*) (cumsigma(j, i), j=1,noOfElem)
c      enddo
c  &&&&&&
      end
