c     Functions to describe the standard atmospher in the vertical direction.
c
c       cthick2den:   atmospheric depth to air density
c       cvh2den:      height to density
c       dvh2denp:     height to d rho/dz
c       dvh2den2p:     height to  d(d rho/dz)/dz
c       cthick2h:     atmospheric depth to height
c       cvh2tthick:   height to thickness(depth)
c
      implicit none
c----      include 'Zstdatmos.h'

c             common for std atmosphere.    
      real*8 AlmostVacH  ! almost vacuum height
      real*8 AlmostVacT  ! thickness there
      parameter (AlmostVacH = 101.d3, AlmostVacT = 1.d-3)

      real*8  ha, hb, hl, hm, hn, hc, t0, hmi, hlhmi

      common /comstdatm/  ha, hb, hl, hm, hn, hc, t0,
     *         hmi, hlhmi
c     -----------------------------------
      real*8 z, den, cvh2den, t

      real*8 cthick2h
      real*8 cvh2thick, temp, denp, den2p
      real*8 cvh2denp, cvh2den2p
c         den = 10.d0* ((ha-z)/hl)**hmi -
c     *                10.d0* ((ha-hc)/hl)**hmi 
c         write(0, *) " amount at z < hc=", den, " >hc =",
c     *             10.d0*exp( (hb-hc)/hn)
c        temp=  10.d0*exp( (hb-hc)/hn) - 10.d0* ((ha-hc)/hl)**hmi 
c         write(0, *) " const to be used in cvh2thick is", temp
     
      do z= -500.d0, 6000.d4, 10000.d0
c         t = 10.d0**z
         den = cvh2den(z)
         denp = cvh2denp(z)
         den2p = cvh2den2p(z)
         t = cvh2thick(z)
         write(*, *)  sngl(z), sngl(den), sngl(denp), sngl(den2p),
     *                sngl(t)
      enddo
      end

